/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreGroup.TCoreGroupPath;
import de.ship.db.tables.TCorePrivilege.TCorePrivilegePath;
import de.ship.db.tables.TCoreUsergroup.TCoreUsergroupPath;
import de.ship.db.tables.TCoreUserprivilege.TCoreUserprivilegePath;
import de.ship.db.tables.TDmDocumentation.TDmDocumentationPath;
import de.ship.db.tables.TDmPerson.TDmPersonPath;
import de.ship.db.tables.TWebSessionstate.TWebSessionstatePath;
import de.ship.db.tables.records.TCorePersonRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCorePerson extends TableImpl<TCorePersonRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_person</code>
     */
    public static final TCorePerson T_CORE_PERSON = new TCorePerson();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCorePersonRecord> getRecordType() {
        return TCorePersonRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_person.lastchange</code>.
     */
    public final TableField<TCorePersonRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_person.usnr</code>. id of user used in
     * database
     */
    public final TableField<TCorePersonRecord, Integer> USNR = createField(DSL.name("usnr"), SQLDataType.INTEGER.nullable(false), this, "id of user used in database");

    /**
     * The column <code>common_dd.t_core_person.username</code>. name of user
     * used for login
     */
    public final TableField<TCorePersonRecord, String> USERNAME = createField(DSL.name("username"), SQLDataType.CLOB.nullable(false), this, "name of user used for login");

    /**
     * The column <code>common_dd.t_core_person.forename</code>.
     */
    public final TableField<TCorePersonRecord, String> FORENAME = createField(DSL.name("forename"), SQLDataType.CLOB.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_person.surname</code>.
     */
    public final TableField<TCorePersonRecord, String> SURNAME = createField(DSL.name("surname"), SQLDataType.CLOB.nullable(false), this, "");

    private TCorePerson(Name alias, Table<TCorePersonRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCorePerson(Name alias, Table<TCorePersonRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_person</code> table reference
     */
    public TCorePerson(String alias) {
        this(DSL.name(alias), T_CORE_PERSON);
    }

    /**
     * Create an aliased <code>common_dd.t_core_person</code> table reference
     */
    public TCorePerson(Name alias) {
        this(alias, T_CORE_PERSON);
    }

    /**
     * Create a <code>common_dd.t_core_person</code> table reference
     */
    public TCorePerson() {
        this(DSL.name("t_core_person"), null);
    }

    public <O extends Record> TCorePerson(Table<O> path, ForeignKey<O, TCorePersonRecord> childPath, InverseForeignKey<O, TCorePersonRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_PERSON);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCorePersonPath extends TCorePerson implements Path<TCorePersonRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCorePersonPath(Table<O> path, ForeignKey<O, TCorePersonRecord> childPath, InverseForeignKey<O, TCorePersonRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCorePersonPath(Name alias, Table<TCorePersonRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCorePersonPath as(String alias) {
            return new TCorePersonPath(DSL.name(alias), this);
        }

        @Override
        public TCorePersonPath as(Name alias) {
            return new TCorePersonPath(alias, this);
        }

        @Override
        public TCorePersonPath as(Table<?> alias) {
            return new TCorePersonPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public UniqueKey<TCorePersonRecord> getPrimaryKey() {
        return Keys.PK_CORE_PERSON;
    }

    @Override
    public List<UniqueKey<TCorePersonRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_USERNAME);
    }

    private transient TCoreUsergroupPath _tCoreUsergroup;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_usergroup</code> table
     */
    public TCoreUsergroupPath tCoreUsergroup() {
        if (_tCoreUsergroup == null)
            _tCoreUsergroup = new TCoreUsergroupPath(this, null, Keys.T_CORE_USERGROUP__FK_CORE_USERGROUP_USNR.getInverseKey());

        return _tCoreUsergroup;
    }

    private transient TCoreUserprivilegePath _tCoreUserprivilege;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_core_userprivilege</code> table
     */
    public TCoreUserprivilegePath tCoreUserprivilege() {
        if (_tCoreUserprivilege == null)
            _tCoreUserprivilege = new TCoreUserprivilegePath(this, null, Keys.T_CORE_USERPRIVILEGE__FK_CORE_USERPRIVILEGE_USNR.getInverseKey());

        return _tCoreUserprivilege;
    }

    private transient TDmDocumentationPath _tDmDocumentation;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_documentation</code> table
     */
    public TDmDocumentationPath tDmDocumentation() {
        if (_tDmDocumentation == null)
            _tDmDocumentation = new TDmDocumentationPath(this, null, Keys.T_DM_DOCUMENTATION__FK_DM_DOCUMENTATION_RESP.getInverseKey());

        return _tDmDocumentation;
    }

    private transient TDmPersonPath _tDmPerson;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_person</code> table
     */
    public TDmPersonPath tDmPerson() {
        if (_tDmPerson == null)
            _tDmPerson = new TDmPersonPath(this, null, Keys.T_DM_PERSON__FK_USNR_PERSON.getInverseKey());

        return _tDmPerson;
    }

    private transient TWebSessionstatePath _tWebSessionstate;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_web_sessionstate</code> table
     */
    public TWebSessionstatePath tWebSessionstate() {
        if (_tWebSessionstate == null)
            _tWebSessionstate = new TWebSessionstatePath(this, null, Keys.T_WEB_SESSIONSTATE__FK_WEB_SESSIONSTATE_USNR.getInverseKey());

        return _tWebSessionstate;
    }

    /**
     * Get the implicit many-to-many join path to the
     * <code>common_dd.t_core_group</code> table
     */
    public TCoreGroupPath tCoreGroup() {
        return tCoreUsergroup().tCoreGroup();
    }

    /**
     * Get the implicit many-to-many join path to the
     * <code>common_dd.t_core_privilege</code> table
     */
    public TCorePrivilegePath tCorePrivilege() {
        return tCoreUserprivilege().tCorePrivilege();
    }

    @Override
    public TCorePerson as(String alias) {
        return new TCorePerson(DSL.name(alias), this);
    }

    @Override
    public TCorePerson as(Name alias) {
        return new TCorePerson(alias, this);
    }

    @Override
    public TCorePerson as(Table<?> alias) {
        return new TCorePerson(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCorePerson rename(String name) {
        return new TCorePerson(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCorePerson rename(Name name) {
        return new TCorePerson(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCorePerson rename(Table<?> name) {
        return new TCorePerson(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePerson where(Condition condition) {
        return new TCorePerson(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePerson where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePerson where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePerson where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePerson where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePerson where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePerson where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCorePerson where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePerson whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCorePerson whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
